#include <rtm/CorbaNaming.h>
#include <iostream>
#include "MyService.hh"
#include <rtm/NVUtil.h>

int main(int argc, char** argv)
{
  CORBA::ORB_var orb;
  orb = CORBA::ORB_init(argc, argv);

  // RTC::CorbaNaming gpăl[T[oɃANZX
  // http://www.is.aist.go.jp/rt/OpenRTM-aist/doxygen/ClassReference/classRTC_1_1CorbaNaming.html
  RTC::CorbaNaming ns(orb, "localhost");

  // RTObject擾
  // http://www.is.aist.go.jp/rt/OpenRTM-aist/doxygen/IDLReference/interfaceRTC_1_1RTObject.html
  CORBA::Object_var obj = ns.resolve("MyServiceProvider0.rtc");
  RTC::RTObject_var rtc = RTC::RTObject::_narrow(obj);

  // ComponentProfile擾
  // http://www.is.aist.go.jp/rt/OpenRTM-aist/doxygen/IDLReference/structRTC_1_1ComponentProfile.html
  RTC::ComponentProfile* prof;
  prof = rtc->get_component_profile();
  std::cout << "RTC name: " << prof->instance_name << std::endl;

  // PortProfile擾
  // http://www.is.aist.go.jp/rt/OpenRTM-aist/doxygen/IDLReference/structRTC_1_1PortProfile.html
  RTC::PortProfileList port_prof;
  port_prof = prof->port_profiles;
  for (CORBA::ULong i(0), len(port_prof.length()); i < len; ++i)
    {
      std::cout << "name: " << port_prof[i].name << std::endl;

      // C^[tF[X\Ă݂
      //  http://www.is.aist.go.jp/rt/OpenRTM-aist/doxygen/IDLReference/structRTC_1_1PortInterfaceProfile.html
      RTC::PortInterfaceProfileList  ifs(port_prof[i].interfaces);
      for (CORBA::ULong j(0), jlen(ifs.length()); j < jlen; ++j)
	{
	  std::cout << "IF name: " << ifs[j].instance_name << std::endl;
	  std::cout << "IF type: " << ifs[j].type_name << std::endl;
	  const char* pol;
	  pol = ifs[j].polarity == RTC::PROVIDED ? "Provided" : "Required";
	  std::cout << "IF polarity: " << pol << std::endl;
	}
    }

  RTC::Port_var port;
  port = port_prof[0].port_ref;



  //
  // ConnectorProfile portoɎg̃t@X̂ݓ
  // connect B߂ĂConnectorProfileproperties̒ɂ
  // T[rXObjectReferenceĂ̂Ŏ擾B
  //
  // T[rX̐ڑɊւ̓NXt@XCorbaPortQ
  // http://www.is.aist.go.jp/rt/OpenRTM-aist/doxygen/ClassReference/classRTC_1_1CorbaPort.html
  //
  // ConnectorProfile
  // http://www.is.aist.go.jp/rt/OpenRTM-aist/doxygen/IDLReference/structRTC_1_1ConnectorProfile.html
  RTC::ConnectorProfile con_prof;
  con_prof.name = CORBA::string_dup("tekitouna_namae0");
  con_prof.connector_id = "";
  con_prof.ports.length(1);
  con_prof.ports[0] = port;
  con_prof.properties.length(0);
  if (CORBA::is_nil(port))
    {
      std::cout << "nil reference" << std::endl;
      return 0;
    }

  if (port->connect(con_prof) != RTC::RTC_ERROR)
    {
      // G[͖
      std::cout << "ignore error" << std::endl;
    }
  std::cout << "connect OK" << std::endl;

  CORBA::Object_ptr aobj;
  MyService_var mysvc;

  // NVUtilproperties̒T[rX̃IuWFNgt@X擾
  // http://www.is.aist.go.jp/rt/OpenRTM-aist/doxygen/ClassReference/namespaceNVUtil.html
  if (NVUtil::find(con_prof.properties, "port.MyService.myservice0") >>= CORBA::Any::to_object(aobj))
    {
      mysvc = MyService::_narrow(aobj);
    }
  
  // T[rXĂ
  mysvc->echo("hogehoge");
  // MyServiceProvidersʂňȉ̂悤ɕ\͂
  //
  // MyService::echo() was called.
  // Message: hogehoge


  
}
